<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: utils/SmartPointer/SmartPointer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_smart_pointer_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SmartPointer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_SMARTPOINTER_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_SMARTPOINTER_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &quot;ReferenceCounter.h&quot;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="class_smart_pointer.html">   27</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_smart_pointer.html">SmartPointer</a> {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a3fa3ec3cd42af91d449ee93657320a0d">   33</a></span>&#160;    <a class="code" href="class_smart_pointer.html#a3fa3ec3cd42af91d449ee93657320a0d">SmartPointer</a>() : <a class="code" href="class_smart_pointer.html">SmartPointer</a>(0) {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        referenceCounter = <span class="keyword">new</span> <a class="code" href="class_reference_counter.html">ReferenceCounter</a>();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        referenceCounter-&gt;<a class="code" href="class_reference_counter.html#aeb051a137eaf2caa97d3a22cb37f3ce1">addRef</a>();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    }</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#aa0da496313f3ecd876cab0901833e378">   43</a></span>&#160;    <a class="code" href="class_smart_pointer.html#aa0da496313f3ecd876cab0901833e378">SmartPointer</a>(T *pValue) : pointerData(pValue), referenceCounter(0) {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        referenceCounter = <span class="keyword">new</span> <a class="code" href="class_reference_counter.html">ReferenceCounter</a>();</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        referenceCounter-&gt;<a class="code" href="class_reference_counter.html#aeb051a137eaf2caa97d3a22cb37f3ce1">addRef</a>();</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    }</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a50b1873a1c35d2714b2fffecdf5ced4e">   53</a></span>&#160;    <a class="code" href="class_smart_pointer.html#a50b1873a1c35d2714b2fffecdf5ced4e">SmartPointer</a>(<span class="keyword">const</span> <a class="code" href="class_smart_pointer.html">SmartPointer&lt;T&gt;</a> &amp;smartPointer) : pointerData(smartPointer.pointerData),</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;                                                        referenceCounter(smartPointer.referenceCounter) {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        referenceCounter-&gt;<a class="code" href="class_reference_counter.html#aeb051a137eaf2caa97d3a22cb37f3ce1">addRef</a>();</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    }</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a5cadb135f452564cdca23b6e5483adea">   61</a></span>&#160;    <a class="code" href="class_smart_pointer.html#a5cadb135f452564cdca23b6e5483adea">~SmartPointer</a>() {</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordflow">if</span> (referenceCounter-&gt;<a class="code" href="class_reference_counter.html#aa9bf60608f85b55567f9927852d9bfa5">release</a>() &lt; 1) {  <span class="comment">// there are no more references</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="keyword">delete</span> pointerData;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            <span class="keyword">delete</span> referenceCounter;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    }</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#acb5b8c110c53721ef4081888af3157d7">   72</a></span>&#160;    T *<a class="code" href="class_smart_pointer.html#acb5b8c110c53721ef4081888af3157d7">getData</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordflow">return</span> pointerData;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    }</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="comment">// operators</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a0761009e7b8efa6a4d559190ab5c63b1">   83</a></span>&#160;    <a class="code" href="class_smart_pointer.html">SmartPointer&lt;T&gt;</a> &amp;<a class="code" href="class_smart_pointer.html#a0761009e7b8efa6a4d559190ab5c63b1">operator=</a>(<span class="keyword">const</span> <a class="code" href="class_smart_pointer.html">SmartPointer&lt;T&gt;</a> &amp;smartPointer) {</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordflow">if</span> (<span class="keyword">this</span> != &amp;smartPointer) {  <span class="comment">// avoid self assignment</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <span class="comment">// decrement the old reference count</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            <span class="keywordflow">if</span> (referenceCounter-&gt;<a class="code" href="class_reference_counter.html#aa9bf60608f85b55567f9927852d9bfa5">release</a>() == 0) {</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                <span class="keyword">delete</span> pointerData;  <span class="comment">// if reference becomes zero delete the old data</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;                <span class="keyword">delete</span> referenceCounter;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            }</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="comment">// copy the data and reference pointer and increment the reference count</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            pointerData = smartPointer.pointerData;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            referenceCounter = smartPointer.referenceCounter;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            referenceCounter-&gt;<a class="code" href="class_reference_counter.html#aeb051a137eaf2caa97d3a22cb37f3ce1">addRef</a>();</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    }</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a15f5644df6d0bd40c91225eff75b6f8f">  104</a></span>&#160;    T &amp;<a class="code" href="class_smart_pointer.html#a15f5644df6d0bd40c91225eff75b6f8f">operator*</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordflow">return</span> *pointerData;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    }</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#aad35d616e03295f6ec614eb18679974f">  112</a></span>&#160;    T *<a class="code" href="class_smart_pointer.html#aad35d616e03295f6ec614eb18679974f">operator-&gt;</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keywordflow">return</span> pointerData;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    }</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a2e65033a247a3bf1f0da6a509aefacad">  121</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_smart_pointer.html#a2e65033a247a3bf1f0da6a509aefacad">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_smart_pointer.html">SmartPointer</a> &amp;other)<span class="keyword"> const </span>{</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordflow">return</span> *<a class="code" href="class_smart_pointer.html#acb5b8c110c53721ef4081888af3157d7">getData</a>() == *other.<a class="code" href="class_smart_pointer.html#acb5b8c110c53721ef4081888af3157d7">getData</a>();</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    }</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a343dbf7081c30a90eb1e1f7212291d33">  130</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_smart_pointer.html#a343dbf7081c30a90eb1e1f7212291d33">operator!=</a>(<span class="keyword">const</span> <a class="code" href="class_smart_pointer.html">SmartPointer</a> &amp;other)<span class="keyword"> const </span>{</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == other);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    }</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a0070f3c260e7d3677221c6a6554b832d">  140</a></span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_smart_pointer.html#a0070f3c260e7d3677221c6a6554b832d">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_smart_pointer.html">SmartPointer</a> &amp;smartPointer) {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keywordflow">return</span> out &lt;&lt; *smartPointer.<a class="code" href="class_smart_pointer.html#acb5b8c110c53721ef4081888af3157d7">getData</a>();</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    }</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno"><a class="line" href="class_smart_pointer.html#a468bd45816fb399075283a1151b4e22a">  150</a></span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_smart_pointer.html#a468bd45816fb399075283a1151b4e22a">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_smart_pointer.html">SmartPointer</a> *smartPointer) {</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordflow">return</span> out &lt;&lt; *smartPointer;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    }</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    T *pointerData; <span class="comment">// generic pointer to be stored</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <a class="code" href="class_reference_counter.html">ReferenceCounter</a> *referenceCounter;  <span class="comment">// reference count</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;};</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="preprocessor">#endif //LIBRARYMGR_SMARTPOINTER_H</span></div><div class="ttc" id="class_smart_pointer_html_a0070f3c260e7d3677221c6a6554b832d"><div class="ttname"><a href="class_smart_pointer.html#a0070f3c260e7d3677221c6a6554b832d">SmartPointer::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;out, const SmartPointer &amp;smartPointer)</div><div class="ttdoc">operator &lt;&lt; printer </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:140</div></div>
<div class="ttc" id="class_smart_pointer_html_a468bd45816fb399075283a1151b4e22a"><div class="ttname"><a href="class_smart_pointer.html#a468bd45816fb399075283a1151b4e22a">SmartPointer::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;out, const SmartPointer *smartPointer)</div><div class="ttdoc">operator &lt;&lt; printer </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:150</div></div>
<div class="ttc" id="class_smart_pointer_html_aa0da496313f3ecd876cab0901833e378"><div class="ttname"><a href="class_smart_pointer.html#aa0da496313f3ecd876cab0901833e378">SmartPointer::SmartPointer</a></div><div class="ttdeci">SmartPointer(T *pValue)</div><div class="ttdef"><b>Definition:</b> SmartPointer.h:43</div></div>
<div class="ttc" id="class_reference_counter_html"><div class="ttname"><a href="class_reference_counter.html">ReferenceCounter</a></div><div class="ttdef"><b>Definition:</b> ReferenceCounter.h:25</div></div>
<div class="ttc" id="class_reference_counter_html_aa9bf60608f85b55567f9927852d9bfa5"><div class="ttname"><a href="class_reference_counter.html#aa9bf60608f85b55567f9927852d9bfa5">ReferenceCounter::release</a></div><div class="ttdeci">int release()</div><div class="ttdef"><b>Definition:</b> ReferenceCounter.cpp:24</div></div>
<div class="ttc" id="class_smart_pointer_html_a2e65033a247a3bf1f0da6a509aefacad"><div class="ttname"><a href="class_smart_pointer.html#a2e65033a247a3bf1f0da6a509aefacad">SmartPointer::operator==</a></div><div class="ttdeci">bool operator==(const SmartPointer &amp;other) const </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:121</div></div>
<div class="ttc" id="class_smart_pointer_html_a50b1873a1c35d2714b2fffecdf5ced4e"><div class="ttname"><a href="class_smart_pointer.html#a50b1873a1c35d2714b2fffecdf5ced4e">SmartPointer::SmartPointer</a></div><div class="ttdeci">SmartPointer(const SmartPointer&lt; T &gt; &amp;smartPointer)</div><div class="ttdef"><b>Definition:</b> SmartPointer.h:53</div></div>
<div class="ttc" id="class_smart_pointer_html_a5cadb135f452564cdca23b6e5483adea"><div class="ttname"><a href="class_smart_pointer.html#a5cadb135f452564cdca23b6e5483adea">SmartPointer::~SmartPointer</a></div><div class="ttdeci">~SmartPointer()</div><div class="ttdef"><b>Definition:</b> SmartPointer.h:61</div></div>
<div class="ttc" id="class_reference_counter_html_aeb051a137eaf2caa97d3a22cb37f3ce1"><div class="ttname"><a href="class_reference_counter.html#aeb051a137eaf2caa97d3a22cb37f3ce1">ReferenceCounter::addRef</a></div><div class="ttdeci">void addRef()</div><div class="ttdef"><b>Definition:</b> ReferenceCounter.cpp:20</div></div>
<div class="ttc" id="class_smart_pointer_html_aad35d616e03295f6ec614eb18679974f"><div class="ttname"><a href="class_smart_pointer.html#aad35d616e03295f6ec614eb18679974f">SmartPointer::operator-&gt;</a></div><div class="ttdeci">T * operator-&gt;() const </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:112</div></div>
<div class="ttc" id="class_smart_pointer_html_a343dbf7081c30a90eb1e1f7212291d33"><div class="ttname"><a href="class_smart_pointer.html#a343dbf7081c30a90eb1e1f7212291d33">SmartPointer::operator!=</a></div><div class="ttdeci">bool operator!=(const SmartPointer &amp;other) const </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:130</div></div>
<div class="ttc" id="class_smart_pointer_html_a15f5644df6d0bd40c91225eff75b6f8f"><div class="ttname"><a href="class_smart_pointer.html#a15f5644df6d0bd40c91225eff75b6f8f">SmartPointer::operator*</a></div><div class="ttdeci">T &amp; operator*() const </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:104</div></div>
<div class="ttc" id="class_smart_pointer_html_a3fa3ec3cd42af91d449ee93657320a0d"><div class="ttname"><a href="class_smart_pointer.html#a3fa3ec3cd42af91d449ee93657320a0d">SmartPointer::SmartPointer</a></div><div class="ttdeci">SmartPointer()</div><div class="ttdef"><b>Definition:</b> SmartPointer.h:33</div></div>
<div class="ttc" id="class_smart_pointer_html_acb5b8c110c53721ef4081888af3157d7"><div class="ttname"><a href="class_smart_pointer.html#acb5b8c110c53721ef4081888af3157d7">SmartPointer::getData</a></div><div class="ttdeci">T * getData() const </div><div class="ttdef"><b>Definition:</b> SmartPointer.h:72</div></div>
<div class="ttc" id="class_smart_pointer_html"><div class="ttname"><a href="class_smart_pointer.html">SmartPointer</a></div><div class="ttdef"><b>Definition:</b> SmartPointer.h:27</div></div>
<div class="ttc" id="class_smart_pointer_html_a0761009e7b8efa6a4d559190ab5c63b1"><div class="ttname"><a href="class_smart_pointer.html#a0761009e7b8efa6a4d559190ab5c63b1">SmartPointer::operator=</a></div><div class="ttdeci">SmartPointer&lt; T &gt; &amp; operator=(const SmartPointer&lt; T &gt; &amp;smartPointer)</div><div class="ttdef"><b>Definition:</b> SmartPointer.h:83</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_cbdb8362360e11eafe2fa3bc74cf0ffd.html">utils</a></li><li class="navelem"><a class="el" href="dir_de5b01bbeed8dbfd3b66b9e69839af9f.html">SmartPointer</a></li><li class="navelem"><b>SmartPointer.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
